package testing.ConsoleReader;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

public class ConsoleReader implements Runnable
{
	private boolean bExit = false;
	
	private boolean bPause = false;
	
	private BufferedReader br = new BufferedReader(new InputStreamReader(
			System.in));
	
	private String sInput;
	
	public boolean isExit()
	{
		return bExit;
	}
	
	public boolean isPaused()
	{
		return bPause;
	}
	
	@Override
	public void run()
	{
		printTitle();
		
		do
		{
			try
			{
				sInput = br.readLine();
				
				sInput = sInput.toLowerCase();
			}
			catch (IOException e)
			{
				System.out.println("IO error trying to read your command!");
			}
			
			if (sInput.equals("quit"))
			{
				bExit = true;
				
				System.out.println("Goodbye!");
			}
			else if (sInput.equals("pause"))
			{
				if (!bPause)
				{
					bPause = true;
					
					System.out.println("Threads paused...");
				}
				else if (bPause)
				{
					System.out
							.println("Threads already paused! Type 'resume' "
									+ "to resume thread execution.");
				}
				
			}
			else if (sInput.equals("resume"))
			{
				if (!bPause)
				{
					System.out.println("Threads not paused! Type 'pause' "
							+ "to pause thread execution.");
				}
				else if (bPause)
				{
					bPause = false;
					System.out.println("Thread execution resumed...");
				}
			}
			else if (sInput.equals("help"))
			{
				printHelp();
			}
			else
			{
				System.out.println("'" + sInput + "' not recognized as a "
						+ "valid command.");
				
				printHelp();
			}
			
		} while (!bExit);
	}
	
	private void printHelp()
	{
		System.out.println("Type 'quit' to Exit the application.\n"
				+ "Type 'pause' to pause thread execution.\n"
				+ "Type 'resume' to resume thread execution.\n"
				+ "Type 'help' for help.");
	}
	
	private void printTitle()
	{
		System.out.println("********** Daemon **********\n"
				+ "Type 'help' and press ENTER for commands.");
	}
}
